<template>
    <aside class="min-h-screen bg-primary-30 border-r-2 border-secondary-20 relative"
        @mouseover="() => { if (!isOpen) openHover = true }" @mouseleave="() => { if (!isOpen) openHover = false }"
        :class="[(isOpen || openHover) ? 'w-64' : 'w-16']" aria-label="Sidebar">
        <div class="overflow-y-auto py-4 px-0">
            <div class="flex w-full justify-center pt-[15px] pb-[27px]" :class="{ 'pt-[10px]': (!isOver) }">
                <img class="duration-300  w-[100px] rounded-[50px] mt-[-15px]" src="@/assets/plogo.png" :class="{ 'w-[30px] h-[30px]': (!isOver) }" />
            </div>
            <ul class="space-y-2 overflow-y-auto max-menu-vh no-scrollbar">
                <li v-for="(item, i) of items" :key="i">
                    <router-link v-if="!item.child" :to="item?.path"
                        class="flex items-center p-2 px-5 text-base font-normal text-white hover:bg-primary-70 hover:hover:bg-primary-70 hover:border-l-4 hover:border-primary-70">
                        <fa-icon class="text-lg" :icon="`fa-solid ${item?.icon}`" />
                        <span :class="{ 'hidden': (!isOver) }" class="ml-3 font-mm text-[14px]">{{ item?.name
                        }}</span>
                    </router-link>
                    <div v-else>
                        <button
                            :class="{ 'bg-primary-70 border-l-4 border-primary-70': subIsActive(item?.path), 'bg-primary-70': isOverExpend(item) }"
                            type="button" class="flex items-center p-2 px-5 w-full text-base font-normal text-white transition duration-75 group hover:hover:bg-primary-70 hover:border-l-4 
                            hover:border-primary-70 open:border-primary-70" @click="onClickExpend(item)">
                            <fa-icon class="text-lg" :icon="`fa-solid ${item?.icon}`" />
                            <span :class="{ 'hidden': (!isOver) }"
                                class="font-mm flex-1 ml-3 text-[14px] text-left whitespace-nowrap"
                                sidebar-toggle-item>{{
                                        item?.name
                                }}</span>
                            <svg :class="{ 'rotate-90': isOverExpend(item), 'hidden': (!isOver) }" class="duration-500"
                                width="11" height="19" viewBox="0 0 11 19" fill="none"
                                xmlns="http://www.w3.org/2000/svg">
                                <path d="M1 1L9 8.76087L1 18" stroke="#E2B124" stroke-width="2" />
                            </svg>
                        </button>
                        <ul class="space-y-2 text-white transition duration-100"
                            :class="{ 'hidden': !isOverExpend(item), 'bg-primary-70': isOverExpend(item) }">
                            <li v-for="childItem of item?.child" :key="childItem">
                                <router-link v-if="!childItem.child" :to="childItem?.path"
                                    :class="{ 'border-0': subIsActive(item?.path) }"
                                    class="flex items-center p-2 pl-11 w-full text-white text-base font-normal transition duration-75 group hover:hover:bg-primary-70">
                                    <fa-icon :icon="`fa-solid ${childItem?.icon}`" />
                                    <span class="flex-1 font-mm ml-2 text-[14px] text-left whitespace-nowrap">{{
                                            childItem?.name
                                    }}</span>
                                </router-link>
                            </li>
                        </ul>
                    </div>
                </li>

            </ul>
           
        </div>
    </aside>
</template>

<script>
export default {
    name: 'v-sidebar',
    props: {
        items: {
            type: Array,
            require: true
        },
        isOpen: {
            type: Boolean,
            default: true
        }
    },
    computed: {
        isOver() {
            if (!this.isOpen) {
                return this.openHover;
            }

            return this.isOpen;
        }
    },
    data: () => ({
        openHover: false,
        open: false,
        isClicked: false
    }),
    methods: {
        onClickExpend(item) {
            item.open = !item?.open;
            this.isClicked = true;
        },
        isOverExpend(item) {
            if (!this.isOpen) {
                return this.openHover && item?.open;
            }

            if (item?.open || this.isClicked) {
                return item?.open;
            }

            return this.subIsActive(item.path);
        },
        subIsActive(input) {
            const paths = Array.isArray(input) ? input : [input]
            return paths.some(path => {
                return this.$route.path.indexOf(path) === 0
            })
        }
    }
}
</script>

<style>
</style>